/* desktop-notifications.c generated by valac 0.48.9, the Vala compiler
 * generated from desktop-notifications.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2019 Michael Gratton <mike@vee.net>.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later). See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <glib.h>
#include <libpeas/peas.h>
#include "geary-client-3.36.h"
#include <gio/gio.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define PLUGIN_TYPE_DESKTOP_NOTIFICATIONS (plugin_desktop_notifications_get_type ())
#define PLUGIN_DESKTOP_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications))
#define PLUGIN_DESKTOP_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotificationsClass))
#define PLUGIN_IS_DESKTOP_NOTIFICATIONS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), PLUGIN_TYPE_DESKTOP_NOTIFICATIONS))
#define PLUGIN_IS_DESKTOP_NOTIFICATIONS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), PLUGIN_TYPE_DESKTOP_NOTIFICATIONS))
#define PLUGIN_DESKTOP_NOTIFICATIONS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotificationsClass))

typedef struct _PluginDesktopNotifications PluginDesktopNotifications;
typedef struct _PluginDesktopNotificationsClass PluginDesktopNotificationsClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _PluginDesktopNotificationsPrivate PluginDesktopNotificationsPrivate;
enum  {
	PLUGIN_DESKTOP_NOTIFICATIONS_0_PROPERTY,
	PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY,
	PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY,
	PLUGIN_DESKTOP_NOTIFICATIONS_NUM_PROPERTIES
};
static GParamSpec* plugin_desktop_notifications_properties[PLUGIN_DESKTOP_NOTIFICATIONS_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _PluginDesktopNotificationsNotifyOneMessageData PluginDesktopNotificationsNotifyOneMessageData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PluginDesktopNotifications {
	PluginNotification parent_instance;
	PluginDesktopNotificationsPrivate * priv;
};

struct _PluginDesktopNotificationsClass {
	PluginNotificationClass parent_class;
};

struct _PluginDesktopNotificationsPrivate {
	ApplicationClient* _application;
	ApplicationNotificationContext* _context;
	GNotification* arrived_notification;
	GCancellable* cancellable;
};

struct _PluginDesktopNotificationsNotifyOneMessageData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	PluginDesktopNotifications* self;
	GearyFolder* folder;
	GearyEmail* email;
	GCancellable* cancellable;
	GearyRFC822MailboxAddress* originator;
	GearyRFC822MailboxAddress* _tmp0_;
	GearyRFC822MailboxAddress* _tmp1_;
	ApplicationContactStore* contacts;
	ApplicationNotificationContext* _tmp2_;
	ApplicationNotificationContext* _tmp3_;
	GearyAccount* _tmp4_;
	GearyAccount* _tmp5_;
	ApplicationContactStore* _tmp6_;
	ApplicationContact* contact;
	ApplicationContactStore* _tmp7_;
	GearyRFC822MailboxAddress* _tmp8_;
	ApplicationContact* _tmp9_;
	gint count;
	gint _tmp10_;
	ApplicationNotificationContext* _tmp11_;
	ApplicationNotificationContext* _tmp12_;
	gchar* body;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	GearyAccount* _tmp17_;
	GearyAccount* _tmp18_;
	GearyAccountInformation* _tmp19_;
	GearyAccountInformation* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	ApplicationContact* _tmp25_;
	gboolean _tmp26_;
	gboolean _tmp27_;
	ApplicationContact* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	GearyRFC822MailboxAddress* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	GearyEmailIdentifier* _tmp35_;
	GearyEmailIdentifier* _tmp36_;
	GError* _inner_error0_;
};

static gint PluginDesktopNotifications_private_offset;
static gpointer plugin_desktop_notifications_parent_class = NULL;
static GType plugin_desktop_notifications_type_id = 0;

void peas_register_types (GTypeModule* module);
GType plugin_desktop_notifications_register_type (GTypeModule * module);
GType plugin_desktop_notifications_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (PluginDesktopNotifications, g_object_unref)
#define PLUGIN_DESKTOP_NOTIFICATIONS_REQUIRED_FIELDS (GEARY_EMAIL_FIELD_ORIGINATORS | GEARY_EMAIL_FIELD_SUBJECT)
#define PLUGIN_DESKTOP_NOTIFICATIONS_ARRIVED_ID "email-arrived"
static void plugin_desktop_notifications_real_activate (PluginNotification* base);
static void plugin_desktop_notifications_on_new_messages_arrived (PluginDesktopNotifications* self,
                                                           GearyFolder* folder,
                                                           gint total,
                                                           gint added);
static void _plugin_desktop_notifications_on_new_messages_arrived_application_notification_context_new_messages_arrived (ApplicationNotificationContext* _sender,
                                                                                                                  GearyFolder* parent,
                                                                                                                  gint total,
                                                                                                                  gint added,
                                                                                                                  gpointer self);
static void plugin_desktop_notifications_real_deactivate (PluginNotification* base,
                                                   gboolean is_shutdown);
static void plugin_desktop_notifications_clear_arrived_notification (PluginDesktopNotifications* self);
static void plugin_desktop_notifications_notify_new_mail (PluginDesktopNotifications* self,
                                                   GearyFolder* folder,
                                                   gint added);
static void plugin_desktop_notifications_issue_arrived_notification (PluginDesktopNotifications* self,
                                                              const gchar* summary,
                                                              const gchar* body,
                                                              GearyFolder* folder,
                                                              GearyEmailIdentifier* id);
static void plugin_desktop_notifications_notify_one_message_data_free (gpointer _data);
static void plugin_desktop_notifications_notify_one_message (PluginDesktopNotifications* self,
                                                      GearyFolder* folder,
                                                      GearyEmail* email,
                                                      GCancellable* cancellable,
                                                      GAsyncReadyCallback _callback_,
                                                      gpointer _user_data_);
static void plugin_desktop_notifications_notify_one_message_finish (PluginDesktopNotifications* self,
                                                             GAsyncResult* _res_,
                                                             GError** error);
static gboolean plugin_desktop_notifications_notify_one_message_co (PluginDesktopNotificationsNotifyOneMessageData* _data_);
static void plugin_desktop_notifications_notify_one_message_ready (GObject* source_object,
                                                            GAsyncResult* _res_,
                                                            gpointer _user_data_);
static GVariant* _variant_new1 (const gchar* value);
static void _vala_array_add1 (GVariant** * array,
                       gint* length,
                       gint* size,
                       GVariant* value);
static GNotification* plugin_desktop_notifications_issue_notification (PluginDesktopNotifications* self,
                                                                const gchar* id,
                                                                const gchar* summary,
                                                                const gchar* body,
                                                                const gchar* action,
                                                                GVariant* action_target);
PluginDesktopNotifications* plugin_desktop_notifications_new (void);
PluginDesktopNotifications* plugin_desktop_notifications_construct (GType object_type);
static void plugin_desktop_notifications_finalize (GObject * obj);
static void _vala_plugin_desktop_notifications_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_plugin_desktop_notifications_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
peas_register_types (GTypeModule* module)
{
	PeasObjectModule* obj = NULL;
	PeasObjectModule* _tmp0_;
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (module, g_type_module_get_type ()));
	plugin_desktop_notifications_register_type (module);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (module, peas_object_module_get_type ()) ? ((PeasObjectModule*) module) : NULL);
	obj = _tmp0_;
	peas_object_module_register_extension_type (obj, PLUGIN_TYPE_NOTIFICATION, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS);
	_g_object_unref0 (obj);
}

static inline gpointer
plugin_desktop_notifications_get_instance_private (PluginDesktopNotifications* self)
{
	return G_STRUCT_MEMBER_P (self, PluginDesktopNotifications_private_offset);
}

static void
_plugin_desktop_notifications_on_new_messages_arrived_application_notification_context_new_messages_arrived (ApplicationNotificationContext* _sender,
                                                                                                             GearyFolder* parent,
                                                                                                             gint total,
                                                                                                             gint added,
                                                                                                             gpointer self)
{
	plugin_desktop_notifications_on_new_messages_arrived ((PluginDesktopNotifications*) self, parent, total, added);
}

static void
plugin_desktop_notifications_real_activate (PluginNotification* base)
{
	PluginDesktopNotifications * self;
	ApplicationNotificationContext* _tmp0_;
	ApplicationNotificationContext* _tmp1_;
	ApplicationNotificationContext* _tmp2_;
	ApplicationNotificationContext* _tmp3_;
	GCancellable* _tmp4_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	_tmp0_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp1_ = _tmp0_;
	application_notification_context_add_required_fields (_tmp1_, PLUGIN_DESKTOP_NOTIFICATIONS_REQUIRED_FIELDS);
	_tmp2_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp3_ = _tmp2_;
	g_signal_connect_object (_tmp3_, "new-messages-arrived", (GCallback) _plugin_desktop_notifications_on_new_messages_arrived_application_notification_context_new_messages_arrived, self, 0);
	_tmp4_ = g_cancellable_new ();
	_g_object_unref0 (self->priv->cancellable);
	self->priv->cancellable = _tmp4_;
}

static void
plugin_desktop_notifications_real_deactivate (PluginNotification* base,
                                              gboolean is_shutdown)
{
	PluginDesktopNotifications * self;
	GCancellable* _tmp0_;
	ApplicationNotificationContext* _tmp1_;
	ApplicationNotificationContext* _tmp2_;
	guint _tmp3_;
	ApplicationNotificationContext* _tmp4_;
	ApplicationNotificationContext* _tmp5_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	_tmp0_ = self->priv->cancellable;
	g_cancellable_cancel (_tmp0_);
	_tmp1_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp2_ = _tmp1_;
	g_signal_parse_name ("new-messages-arrived", APPLICATION_TYPE_NOTIFICATION_CONTEXT, &_tmp3_, NULL, FALSE);
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _plugin_desktop_notifications_on_new_messages_arrived_application_notification_context_new_messages_arrived, self);
	_tmp4_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp5_ = _tmp4_;
	application_notification_context_remove_required_fields (_tmp5_, PLUGIN_DESKTOP_NOTIFICATIONS_REQUIRED_FIELDS);
	if (!is_shutdown) {
		plugin_desktop_notifications_clear_arrived_notification (self);
	}
}

static void
plugin_desktop_notifications_clear_arrived_notification (PluginDesktopNotifications* self)
{
	ApplicationClient* _tmp0_;
	ApplicationClient* _tmp1_;
	g_return_if_fail (PLUGIN_IS_DESKTOP_NOTIFICATIONS (self));
	_tmp0_ = plugin_notification_get_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp1_ = _tmp0_;
	g_application_withdraw_notification (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_application_get_type (), GApplication), PLUGIN_DESKTOP_NOTIFICATIONS_ARRIVED_ID);
	_g_object_unref0 (self->priv->arrived_notification);
	self->priv->arrived_notification = NULL;
}

static void
plugin_desktop_notifications_notify_new_mail (PluginDesktopNotifications* self,
                                              GearyFolder* folder,
                                              gint added)
{
	gchar* body = NULL;
	gchar* _tmp0_;
	gint total = 0;
	GearyAccount* _tmp6_;
	GearyAccount* _tmp7_;
	GearyAccountInformation* _tmp8_;
	GearyAccountInformation* _tmp9_;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
	const gchar* _tmp12_;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (PLUGIN_IS_DESKTOP_NOTIFICATIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
	_tmp0_ = g_strdup_printf (ngettext ("%d new message", "%d new messages", (gulong) added), added);
	body = _tmp0_;
	total = 0;
	{
		gint _tmp1_ = 0;
		ApplicationNotificationContext* _tmp2_;
		ApplicationNotificationContext* _tmp3_;
		_tmp2_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
		_tmp3_ = _tmp2_;
		_tmp1_ = application_notification_context_get_new_message_count (_tmp3_, folder, &_inner_error0_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
				goto __catch0_geary_engine_error;
			}
			_g_free0 (body);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return;
		}
		total = _tmp1_;
	}
	goto __finally0;
	__catch0_geary_engine_error:
	{
		g_clear_error (&_inner_error0_);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (body);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	if (total > added) {
		const gchar* _tmp4_;
		gchar* _tmp5_;
		_tmp4_ = body;
		_tmp5_ = g_strdup_printf (ngettext ("%s, %d new message total", "%s, %d new messages total", (gulong) total), _tmp4_, total);
		_g_free0 (body);
		body = _tmp5_;
	}
	_tmp6_ = geary_folder_get_account (folder);
	_tmp7_ = _tmp6_;
	_tmp8_ = geary_account_get_information (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = geary_account_information_get_display_name (_tmp9_);
	_tmp11_ = _tmp10_;
	_tmp12_ = body;
	plugin_desktop_notifications_issue_arrived_notification (self, _tmp11_, _tmp12_, folder, NULL);
	_g_free0 (body);
}

static void
plugin_desktop_notifications_notify_one_message_data_free (gpointer _data)
{
	PluginDesktopNotificationsNotifyOneMessageData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->folder);
	_g_object_unref0 (_data_->email);
	_g_object_unref0 (_data_->cancellable);
	_g_object_unref0 (_data_->self);
	g_slice_free (PluginDesktopNotificationsNotifyOneMessageData, _data_);
}

static void
plugin_desktop_notifications_notify_one_message (PluginDesktopNotifications* self,
                                                 GearyFolder* folder,
                                                 GearyEmail* email,
                                                 GCancellable* cancellable,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_)
{
	PluginDesktopNotificationsNotifyOneMessageData* _data_;
	PluginDesktopNotifications* _tmp0_;
	GearyFolder* _tmp1_;
	GearyEmail* _tmp2_;
	GCancellable* _tmp3_;
	_data_ = g_slice_new0 (PluginDesktopNotificationsNotifyOneMessageData);
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, plugin_desktop_notifications_notify_one_message_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = _g_object_ref0 (folder);
	_g_object_unref0 (_data_->folder);
	_data_->folder = _tmp1_;
	_tmp2_ = _g_object_ref0 (email);
	_g_object_unref0 (_data_->email);
	_data_->email = _tmp2_;
	_tmp3_ = _g_object_ref0 (cancellable);
	_g_object_unref0 (_data_->cancellable);
	_data_->cancellable = _tmp3_;
	plugin_desktop_notifications_notify_one_message_co (_data_);
}

static void
plugin_desktop_notifications_notify_one_message_finish (PluginDesktopNotifications* self,
                                                        GAsyncResult* _res_,
                                                        GError** error)
{
	PluginDesktopNotificationsNotifyOneMessageData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
	if (NULL == _data_) {
		return;
	}
}

static void
plugin_desktop_notifications_notify_one_message_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_)
{
	PluginDesktopNotificationsNotifyOneMessageData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	plugin_desktop_notifications_notify_one_message_co (_data_);
}

static gboolean
plugin_desktop_notifications_notify_one_message_co (PluginDesktopNotificationsNotifyOneMessageData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = util_email_get_primary_originator (G_TYPE_CHECK_INSTANCE_CAST (_data_->email, GEARY_TYPE_EMAIL_HEADER_SET, GearyEmailHeaderSet));
	_data_->originator = _data_->_tmp0_;
	_data_->_tmp1_ = _data_->originator;
	if (_data_->_tmp1_ != NULL) {
		_data_->_tmp2_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
		_data_->_tmp3_ = _data_->_tmp2_;
		_data_->_tmp4_ = geary_folder_get_account (_data_->folder);
		_data_->_tmp5_ = _data_->_tmp4_;
		_data_->_tmp6_ = application_notification_context_get_contact_store (_data_->_tmp3_, _data_->_tmp5_);
		_data_->contacts = _data_->_tmp6_;
		_data_->_tmp7_ = _data_->contacts;
		_data_->_tmp8_ = _data_->originator;
		_data_->_state_ = 1;
		application_contact_store_load (_data_->_tmp7_, _data_->_tmp8_, _data_->cancellable, plugin_desktop_notifications_notify_one_message_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp9_ = application_contact_store_load_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error0_);
		_data_->contact = _data_->_tmp9_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->contacts);
			_g_object_unref0 (_data_->originator);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->count = 1;
		{
			_data_->_tmp11_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (_data_->self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
			_data_->_tmp12_ = _data_->_tmp11_;
			_data_->_tmp10_ = application_notification_context_get_new_message_count (_data_->_tmp12_, _data_->folder, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				if (g_error_matches (_data_->_inner_error0_, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
					goto __catch0_geary_engine_error_not_found;
				}
				goto __finally0;
			}
			_data_->count = _data_->_tmp10_;
		}
		goto __finally0;
		__catch0_geary_engine_error_not_found:
		{
			g_clear_error (&_data_->_inner_error0_);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
			_g_object_unref0 (_data_->contact);
			_g_object_unref0 (_data_->contacts);
			_g_object_unref0 (_data_->originator);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
		_data_->_tmp13_ = g_strdup ("");
		_data_->body = _data_->_tmp13_;
		if (_data_->count <= 1) {
			_data_->_tmp14_ = util_email_strip_subject_prefixes (_data_->email);
			_g_free0 (_data_->body);
			_data_->body = _data_->_tmp14_;
		} else {
			_data_->_tmp15_ = util_email_strip_subject_prefixes (_data_->email);
			_data_->_tmp16_ = _data_->_tmp15_;
			_data_->_tmp17_ = geary_folder_get_account (_data_->folder);
			_data_->_tmp18_ = _data_->_tmp17_;
			_data_->_tmp19_ = geary_account_get_information (_data_->_tmp18_);
			_data_->_tmp20_ = _data_->_tmp19_;
			_data_->_tmp21_ = geary_account_information_get_display_name (_data_->_tmp20_);
			_data_->_tmp22_ = _data_->_tmp21_;
			_data_->_tmp23_ = g_strdup_printf (ngettext ("%s\n(%d other new message for %s)", "%s\n(%d other new messages for %s)", (gulong) (_data_->count - 1)), _data_->_tmp16_, _data_->count - 1, _data_->_tmp22_);
			_g_free0 (_data_->body);
			_data_->body = _data_->_tmp23_;
			_g_free0 (_data_->_tmp16_);
		}
		_data_->_tmp25_ = _data_->contact;
		_data_->_tmp26_ = application_contact_get_is_trusted (_data_->_tmp25_);
		_data_->_tmp27_ = _data_->_tmp26_;
		if (_data_->_tmp27_) {
			_data_->_tmp28_ = _data_->contact;
			_data_->_tmp29_ = application_contact_get_display_name (_data_->_tmp28_);
			_data_->_tmp30_ = _data_->_tmp29_;
			_data_->_tmp31_ = g_strdup (_data_->_tmp30_);
			_g_free0 (_data_->_tmp24_);
			_data_->_tmp24_ = _data_->_tmp31_;
		} else {
			_data_->_tmp32_ = _data_->originator;
			_data_->_tmp33_ = geary_rf_c822_mailbox_address_to_short_display (_data_->_tmp32_);
			_g_free0 (_data_->_tmp24_);
			_data_->_tmp24_ = _data_->_tmp33_;
		}
		_data_->_tmp34_ = _data_->body;
		_data_->_tmp35_ = geary_email_get_id (_data_->email);
		_data_->_tmp36_ = _data_->_tmp35_;
		plugin_desktop_notifications_issue_arrived_notification (_data_->self, _data_->_tmp24_, _data_->_tmp34_, _data_->folder, _data_->_tmp36_);
		_g_free0 (_data_->_tmp24_);
		_g_free0 (_data_->body);
		_g_object_unref0 (_data_->contact);
		_g_object_unref0 (_data_->contacts);
	} else {
		plugin_desktop_notifications_notify_new_mail (_data_->self, _data_->folder, 1);
	}
	_g_object_unref0 (_data_->originator);
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static GVariant*
_variant_new1 (const gchar* value)
{
	return g_variant_ref_sink (g_variant_new_string (value));
}

static void
_vala_array_add1 (GVariant** * array,
                  gint* length,
                  gint* size,
                  GVariant* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (GVariant*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
plugin_desktop_notifications_issue_arrived_notification (PluginDesktopNotifications* self,
                                                         const gchar* summary,
                                                         const gchar* body,
                                                         GearyFolder* folder,
                                                         GearyEmailIdentifier* id)
{
	gchar* action = NULL;
	GVariant** target_param = NULL;
	GearyAccount* _tmp0_;
	GearyAccount* _tmp1_;
	GearyAccountInformation* _tmp2_;
	GearyAccountInformation* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GVariant* _tmp6_;
	GearyFolderPath* _tmp7_;
	GearyFolderPath* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* _tmp11_;
	GVariant** _tmp12_;
	GVariant** _tmp13_;
	gint _tmp13__length1;
	gint target_param_length1;
	gint _target_param_size_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GVariant** _tmp22_;
	gint _tmp22__length1;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GNotification* _tmp25_;
	g_return_if_fail (PLUGIN_IS_DESKTOP_NOTIFICATIONS (self));
	g_return_if_fail (summary != NULL);
	g_return_if_fail (body != NULL);
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
	g_return_if_fail ((id == NULL) || G_TYPE_CHECK_INSTANCE_TYPE (id, GEARY_TYPE_EMAIL_IDENTIFIER));
	plugin_desktop_notifications_clear_arrived_notification (self);
	action = NULL;
	_tmp0_ = geary_folder_get_account (folder);
	_tmp1_ = _tmp0_;
	_tmp2_ = geary_account_get_information (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = geary_account_information_get_id (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _variant_new1 (_tmp5_);
	_tmp7_ = geary_folder_get_path (folder);
	_tmp8_ = _tmp7_;
	_tmp9_ = geary_folder_path_to_variant (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = g_variant_new_variant (_tmp10_);
	g_variant_ref_sink (_tmp11_);
	_tmp12_ = g_new0 (GVariant*, 2 + 1);
	_tmp12_[0] = _tmp6_;
	_tmp12_[1] = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp13__length1 = 2;
	_g_variant_unref0 (_tmp10_);
	target_param = _tmp13_;
	target_param_length1 = _tmp13__length1;
	_target_param_size_ = target_param_length1;
	if (id == NULL) {
		gchar* _tmp14_;
		_tmp14_ = g_strdup (ACTION_APPLICATION_SHOW_FOLDER);
		_g_free0 (action);
		action = _tmp14_;
	} else {
		gchar* _tmp15_;
		GVariant* _tmp16_;
		GVariant* _tmp17_;
		GVariant* _tmp18_;
		_tmp15_ = g_strdup (ACTION_APPLICATION_SHOW_EMAIL);
		_g_free0 (action);
		action = _tmp15_;
		_tmp16_ = geary_email_identifier_to_variant (id);
		_tmp17_ = _tmp16_;
		_tmp18_ = g_variant_new_variant (_tmp17_);
		g_variant_ref_sink (_tmp18_);
		_vala_array_add1 (&target_param, &target_param_length1, &_target_param_size_, _tmp18_);
		_g_variant_unref0 (_tmp17_);
	}
	_tmp19_ = action;
	_tmp20_ = action_application_prefix (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = target_param;
	_tmp22__length1 = target_param_length1;
	_tmp23_ = g_variant_new_tuple (_tmp22_, _tmp22__length1);
	g_variant_ref_sink (_tmp23_);
	_tmp24_ = _tmp23_;
	_tmp25_ = plugin_desktop_notifications_issue_notification (self, PLUGIN_DESKTOP_NOTIFICATIONS_ARRIVED_ID, summary, body, _tmp21_, _tmp24_);
	_g_object_unref0 (self->priv->arrived_notification);
	self->priv->arrived_notification = _tmp25_;
	_g_variant_unref0 (_tmp24_);
	_g_free0 (_tmp21_);
	target_param = (_vala_array_free (target_param, target_param_length1, (GDestroyNotify) g_variant_unref), NULL);
	_g_free0 (action);
}

static GNotification*
plugin_desktop_notifications_issue_notification (PluginDesktopNotifications* self,
                                                 const gchar* id,
                                                 const gchar* summary,
                                                 const gchar* body,
                                                 const gchar* action,
                                                 GVariant* action_target)
{
	GNotification* notification = NULL;
	GNotification* _tmp0_;
	GNotification* _tmp1_;
	GNotification* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GThemedIcon* _tmp5_;
	GThemedIcon* _tmp6_;
	ApplicationClient* _tmp7_;
	ApplicationClient* _tmp8_;
	ApplicationConfiguration* _tmp9_;
	ApplicationConfiguration* _tmp10_;
	ApplicationConfigurationDesktopEnvironment _tmp11_;
	ApplicationConfigurationDesktopEnvironment _tmp12_;
	GNotification* result = NULL;
	g_return_val_if_fail (PLUGIN_IS_DESKTOP_NOTIFICATIONS (self), NULL);
	g_return_val_if_fail (id != NULL, NULL);
	g_return_val_if_fail (summary != NULL, NULL);
	g_return_val_if_fail (body != NULL, NULL);
	_tmp0_ = g_notification_new (summary);
	notification = _tmp0_;
	_tmp1_ = notification;
	g_notification_set_body (_tmp1_, body);
	_tmp2_ = notification;
	_tmp3_ = g_strdup_printf ("%s-symbolic", APPLICATION_CLIENT_APP_ID);
	_tmp4_ = _tmp3_;
	_tmp5_ = (GThemedIcon*) g_themed_icon_new (_tmp4_);
	_tmp6_ = _tmp5_;
	g_notification_set_icon (_tmp2_, G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, g_icon_get_type (), GIcon));
	_g_object_unref0 (_tmp6_);
	_g_free0 (_tmp4_);
	_tmp7_ = plugin_notification_get_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp8_ = _tmp7_;
	_tmp9_ = application_client_get_config (_tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = application_configuration_get_desktop_environment (_tmp10_);
	_tmp12_ = _tmp11_;
	if (_tmp12_ == APPLICATION_CONFIGURATION_DESKTOP_ENVIRONMENT_UNITY) {
		ApplicationClient* _tmp13_;
		ApplicationClient* _tmp14_;
		GNotification* _tmp15_;
		_tmp13_ = plugin_notification_get_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
		_tmp14_ = _tmp13_;
		_tmp15_ = notification;
		g_application_send_notification (G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, g_application_get_type (), GApplication), id, _tmp15_);
		result = notification;
		return result;
	} else {
		ApplicationClient* _tmp17_;
		ApplicationClient* _tmp18_;
		GNotification* _tmp19_;
		if (action != NULL) {
			GNotification* _tmp16_;
			_tmp16_ = notification;
			g_notification_set_default_action_and_target_value (_tmp16_, action, action_target);
		}
		_tmp17_ = plugin_notification_get_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
		_tmp18_ = _tmp17_;
		_tmp19_ = notification;
		g_application_send_notification (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, g_application_get_type (), GApplication), id, _tmp19_);
		result = notification;
		return result;
	}
	_g_object_unref0 (notification);
}

static void
plugin_desktop_notifications_on_new_messages_arrived (PluginDesktopNotifications* self,
                                                      GearyFolder* folder,
                                                      gint total,
                                                      gint added)
{
	ApplicationNotificationContext* _tmp0_;
	ApplicationNotificationContext* _tmp1_;
	g_return_if_fail (PLUGIN_IS_DESKTOP_NOTIFICATIONS (self));
	g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (folder, GEARY_TYPE_FOLDER));
	_tmp0_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
	_tmp1_ = _tmp0_;
	if (application_notification_context_should_notify_new_messages (_tmp1_, folder)) {
		gboolean _tmp2_ = FALSE;
		gboolean _tmp3_ = FALSE;
		if (added == 1) {
			ApplicationNotificationContext* _tmp4_;
			ApplicationNotificationContext* _tmp5_;
			GearyFolder* _tmp6_;
			GearyFolder* _tmp7_;
			_tmp4_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
			_tmp5_ = _tmp4_;
			_tmp6_ = application_notification_context_get_last_new_message_folder (_tmp5_);
			_tmp7_ = _tmp6_;
			_tmp3_ = _tmp7_ != NULL;
		} else {
			_tmp3_ = FALSE;
		}
		if (_tmp3_) {
			ApplicationNotificationContext* _tmp8_;
			ApplicationNotificationContext* _tmp9_;
			GearyEmail* _tmp10_;
			GearyEmail* _tmp11_;
			_tmp8_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
			_tmp9_ = _tmp8_;
			_tmp10_ = application_notification_context_get_last_new_message (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp2_ = _tmp11_ != NULL;
		} else {
			_tmp2_ = FALSE;
		}
		if (_tmp2_) {
			ApplicationNotificationContext* _tmp12_;
			ApplicationNotificationContext* _tmp13_;
			GearyFolder* _tmp14_;
			GearyFolder* _tmp15_;
			ApplicationNotificationContext* _tmp16_;
			ApplicationNotificationContext* _tmp17_;
			GearyEmail* _tmp18_;
			GearyEmail* _tmp19_;
			GCancellable* _tmp20_;
			_tmp12_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
			_tmp13_ = _tmp12_;
			_tmp14_ = application_notification_context_get_last_new_message_folder (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification));
			_tmp17_ = _tmp16_;
			_tmp18_ = application_notification_context_get_last_new_message (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = self->priv->cancellable;
			plugin_desktop_notifications_notify_one_message (self, _tmp15_, _tmp19_, _tmp20_, NULL, NULL);
		} else {
			if (added > 0) {
				plugin_desktop_notifications_notify_new_mail (self, folder, added);
			}
		}
	}
}

PluginDesktopNotifications*
plugin_desktop_notifications_construct (GType object_type)
{
	PluginDesktopNotifications * self = NULL;
	self = (PluginDesktopNotifications*) plugin_notification_construct (object_type);
	return self;
}

PluginDesktopNotifications*
plugin_desktop_notifications_new (void)
{
	return plugin_desktop_notifications_construct (PLUGIN_TYPE_DESKTOP_NOTIFICATIONS);
}

static ApplicationClient*
plugin_desktop_notifications_real_get_application (PluginNotification* base)
{
	ApplicationClient* result;
	PluginDesktopNotifications* self;
	ApplicationClient* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	_tmp0_ = self->priv->_application;
	result = _tmp0_;
	return result;
}

static void
plugin_desktop_notifications_real_set_application (PluginNotification* base,
                                                   ApplicationClient* value)
{
	PluginDesktopNotifications* self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	if (plugin_desktop_notifications_real_get_application (base) != value) {
		ApplicationClient* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_application);
		self->priv->_application = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plugin_desktop_notifications_properties[PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY]);
	}
}

static ApplicationNotificationContext*
plugin_desktop_notifications_real_get_context (PluginNotification* base)
{
	ApplicationNotificationContext* result;
	PluginDesktopNotifications* self;
	ApplicationNotificationContext* _tmp0_;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	_tmp0_ = self->priv->_context;
	result = _tmp0_;
	return result;
}

static void
plugin_desktop_notifications_real_set_context (PluginNotification* base,
                                               ApplicationNotificationContext* value)
{
	PluginDesktopNotifications* self;
	self = G_TYPE_CHECK_INSTANCE_CAST (base, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	if (plugin_desktop_notifications_real_get_context (base) != value) {
		ApplicationNotificationContext* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_context);
		self->priv->_context = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, plugin_desktop_notifications_properties[PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY]);
	}
}

static void
plugin_desktop_notifications_class_init (PluginDesktopNotificationsClass * klass,
                                         gpointer klass_data)
{
	plugin_desktop_notifications_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PluginDesktopNotifications_private_offset);
	((PluginNotificationClass *) klass)->activate = (void (*) (PluginNotification*)) plugin_desktop_notifications_real_activate;
	((PluginNotificationClass *) klass)->deactivate = (void (*) (PluginNotification*, gboolean)) plugin_desktop_notifications_real_deactivate;
	PLUGIN_NOTIFICATION_CLASS (klass)->get_application = plugin_desktop_notifications_real_get_application;
	PLUGIN_NOTIFICATION_CLASS (klass)->set_application = plugin_desktop_notifications_real_set_application;
	PLUGIN_NOTIFICATION_CLASS (klass)->get_context = plugin_desktop_notifications_real_get_context;
	PLUGIN_NOTIFICATION_CLASS (klass)->set_context = plugin_desktop_notifications_real_set_context;
	G_OBJECT_CLASS (klass)->get_property = _vala_plugin_desktop_notifications_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_plugin_desktop_notifications_set_property;
	G_OBJECT_CLASS (klass)->finalize = plugin_desktop_notifications_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY, plugin_desktop_notifications_properties[PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY] = g_param_spec_object ("application", "application", "application", APPLICATION_TYPE_CLIENT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY, plugin_desktop_notifications_properties[PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY] = g_param_spec_object ("context", "context", "context", APPLICATION_TYPE_NOTIFICATION_CONTEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
}

static void
plugin_desktop_notifications_instance_init (PluginDesktopNotifications * self,
                                            gpointer klass)
{
	self->priv = plugin_desktop_notifications_get_instance_private (self);
	self->priv->arrived_notification = NULL;
	self->priv->cancellable = NULL;
}

static void
plugin_desktop_notifications_finalize (GObject * obj)
{
	PluginDesktopNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	_g_object_unref0 (self->priv->_application);
	_g_object_unref0 (self->priv->_context);
	_g_object_unref0 (self->priv->arrived_notification);
	_g_object_unref0 (self->priv->cancellable);
	G_OBJECT_CLASS (plugin_desktop_notifications_parent_class)->finalize (obj);
}

/**
 * Manages standard desktop application notifications.
 */
GType
plugin_desktop_notifications_get_type (void)
{
	return plugin_desktop_notifications_type_id;
}

GType
plugin_desktop_notifications_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (PluginDesktopNotificationsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) plugin_desktop_notifications_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PluginDesktopNotifications), 0, (GInstanceInitFunc) plugin_desktop_notifications_instance_init, NULL };
	plugin_desktop_notifications_type_id = g_type_module_register_type (module, PLUGIN_TYPE_NOTIFICATION, "PluginDesktopNotifications", &g_define_type_info, 0);
	PluginDesktopNotifications_private_offset = sizeof (PluginDesktopNotificationsPrivate);
	return plugin_desktop_notifications_type_id;
}

static void
_vala_plugin_desktop_notifications_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	PluginDesktopNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	switch (property_id) {
		case PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY:
		g_value_set_object (value, plugin_notification_get_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification)));
		break;
		case PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY:
		g_value_set_object (value, plugin_notification_get_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification)));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_plugin_desktop_notifications_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	PluginDesktopNotifications * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, PLUGIN_TYPE_DESKTOP_NOTIFICATIONS, PluginDesktopNotifications);
	switch (property_id) {
		case PLUGIN_DESKTOP_NOTIFICATIONS_APPLICATION_PROPERTY:
		plugin_notification_set_application (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification), g_value_get_object (value));
		break;
		case PLUGIN_DESKTOP_NOTIFICATIONS_CONTEXT_PROPERTY:
		plugin_notification_set_context (G_TYPE_CHECK_INSTANCE_CAST (self, PLUGIN_TYPE_NOTIFICATION, PluginNotification), g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

