/* geary-service-provider.c generated by valac 0.48.9, the Vala compiler
 * generated from geary-service-provider.vala, do not modify */

/*
 * Copyright 2016 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>

typedef enum  {
	GEARY_SERVICE_PROVIDER_GMAIL,
	GEARY_SERVICE_PROVIDER_YAHOO,
	GEARY_SERVICE_PROVIDER_OUTLOOK,
	GEARY_SERVICE_PROVIDER_OTHER
} GearyServiceProvider;

#define GEARY_TYPE_SERVICE_PROVIDER (geary_service_provider_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))

#define GEARY_TYPE_BASE_OBJECT (geary_base_object_get_type ())
#define GEARY_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObject))
#define GEARY_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))
#define GEARY_IS_BASE_OBJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_BASE_OBJECT))
#define GEARY_IS_BASE_OBJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_BASE_OBJECT))
#define GEARY_BASE_OBJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_BASE_OBJECT, GearyBaseObjectClass))

typedef struct _GearyBaseObject GearyBaseObject;
typedef struct _GearyBaseObjectClass GearyBaseObjectClass;

#define GEARY_TYPE_ACCOUNT_INFORMATION (geary_account_information_get_type ())
#define GEARY_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformation))
#define GEARY_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))
#define GEARY_IS_ACCOUNT_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_IS_ACCOUNT_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_ACCOUNT_INFORMATION))
#define GEARY_ACCOUNT_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_ACCOUNT_INFORMATION, GearyAccountInformationClass))

typedef struct _GearyAccountInformation GearyAccountInformation;
typedef struct _GearyAccountInformationClass GearyAccountInformationClass;

#define GEARY_TYPE_SERVICE_INFORMATION (geary_service_information_get_type ())
#define GEARY_SERVICE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformation))
#define GEARY_SERVICE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformationClass))
#define GEARY_IS_SERVICE_INFORMATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GEARY_TYPE_SERVICE_INFORMATION))
#define GEARY_IS_SERVICE_INFORMATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GEARY_TYPE_SERVICE_INFORMATION))
#define GEARY_SERVICE_INFORMATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GEARY_TYPE_SERVICE_INFORMATION, GearyServiceInformationClass))

typedef struct _GearyServiceInformation GearyServiceInformation;
typedef struct _GearyServiceInformationClass GearyServiceInformationClass;

typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()

GType geary_service_provider_get_type (void) G_GNUC_CONST;
GQuark geary_engine_error_quark (void);
GearyServiceProvider geary_service_provider_for_value (const gchar* value,
                                                       GError** error);
gpointer geary_object_utils_from_enum_nick (GType e_type,
                                            GBoxedCopyFunc e_dup_func,
                                            GDestroyNotify e_destroy_func,
                                            GType type,
                                            const gchar* nick,
                                            GError** error);
gchar* geary_service_provider_to_value (GearyServiceProvider self);
gchar* geary_object_utils_to_enum_nick (GType e_type,
                                        GBoxedCopyFunc e_dup_func,
                                        GDestroyNotify e_destroy_func,
                                        GType type,
                                        gconstpointer value);
GType geary_base_object_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyBaseObject, g_object_unref)
GType geary_account_information_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyAccountInformation, g_object_unref)
void geary_service_provider_set_account_defaults (GearyServiceProvider self,
                                                  GearyAccountInformation* service);
void geary_imap_engine_gmail_account_setup_account (GearyAccountInformation* account);
void geary_imap_engine_yahoo_account_setup_account (GearyAccountInformation* account);
void geary_imap_engine_outlook_account_setup_account (GearyAccountInformation* account);
GType geary_service_information_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GearyServiceInformation, g_object_unref)
void geary_service_provider_set_service_defaults (GearyServiceProvider self,
                                                  GearyServiceInformation* service);
void geary_imap_engine_gmail_account_setup_service (GearyServiceInformation* service);
void geary_imap_engine_yahoo_account_setup_service (GearyServiceInformation* service);
void geary_imap_engine_outlook_account_setup_service (GearyServiceInformation* service);

/**
 * A representation of the various built-in email service providers Geary supports.
 */
GearyServiceProvider
geary_service_provider_for_value (const gchar* value,
                                  GError** error)
{
	GearyServiceProvider _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GearyServiceProvider _tmp4_;
	GError* _inner_error0_ = NULL;
	GearyServiceProvider result = 0;
	g_return_val_if_fail (value != NULL, 0);
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
	_tmp2_ = _tmp1_;
	_tmp3_ = geary_object_utils_from_enum_nick (GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, GEARY_TYPE_SERVICE_PROVIDER, _tmp2_, &_inner_error0_);
	_tmp4_ = (GearyServiceProvider) ((gintptr) _tmp3_);
	_g_free0 (_tmp2_);
	_tmp0_ = _tmp4_;
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		if (_inner_error0_->domain == GEARY_ENGINE_ERROR) {
			g_propagate_error (error, _inner_error0_);
			return 0;
		} else {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return 0;
		}
	}
	result = _tmp0_;
	return result;
}

gchar*
geary_service_provider_to_value (GearyServiceProvider self)
{
	gchar* _tmp0_;
	gchar* result = NULL;
	_tmp0_ = geary_object_utils_to_enum_nick (GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, GEARY_TYPE_SERVICE_PROVIDER, (gpointer) ((gintptr) self));
	result = _tmp0_;
	return result;
}

void
geary_service_provider_set_account_defaults (GearyServiceProvider self,
                                             GearyAccountInformation* service)
{
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (service));
	switch (self) {
		case GEARY_SERVICE_PROVIDER_GMAIL:
		{
			geary_imap_engine_gmail_account_setup_account (service);
			break;
		}
		case GEARY_SERVICE_PROVIDER_YAHOO:
		{
			geary_imap_engine_yahoo_account_setup_account (service);
			break;
		}
		case GEARY_SERVICE_PROVIDER_OUTLOOK:
		{
			geary_imap_engine_outlook_account_setup_account (service);
			break;
		}
		default:
		break;
	}
}

void
geary_service_provider_set_service_defaults (GearyServiceProvider self,
                                             GearyServiceInformation* service)
{
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
	switch (self) {
		case GEARY_SERVICE_PROVIDER_GMAIL:
		{
			geary_imap_engine_gmail_account_setup_service (service);
			break;
		}
		case GEARY_SERVICE_PROVIDER_YAHOO:
		{
			geary_imap_engine_yahoo_account_setup_service (service);
			break;
		}
		case GEARY_SERVICE_PROVIDER_OUTLOOK:
		{
			geary_imap_engine_outlook_account_setup_service (service);
			break;
		}
		default:
		break;
	}
}

G_GNUC_NO_INLINE static GType
geary_service_provider_get_type_once (void)
{
	static const GEnumValue values[] = {{GEARY_SERVICE_PROVIDER_GMAIL, "GEARY_SERVICE_PROVIDER_GMAIL", "gmail"}, {GEARY_SERVICE_PROVIDER_YAHOO, "GEARY_SERVICE_PROVIDER_YAHOO", "yahoo"}, {GEARY_SERVICE_PROVIDER_OUTLOOK, "GEARY_SERVICE_PROVIDER_OUTLOOK", "outlook"}, {GEARY_SERVICE_PROVIDER_OTHER, "GEARY_SERVICE_PROVIDER_OTHER", "other"}, {0, NULL, NULL}};
	GType geary_service_provider_type_id;
	geary_service_provider_type_id = g_enum_register_static ("GearyServiceProvider", values);
	return geary_service_provider_type_id;
}

GType
geary_service_provider_get_type (void)
{
	static volatile gsize geary_service_provider_type_id__volatile = 0;
	if (g_once_init_enter (&geary_service_provider_type_id__volatile)) {
		GType geary_service_provider_type_id;
		geary_service_provider_type_id = geary_service_provider_get_type_once ();
		g_once_init_leave (&geary_service_provider_type_id__volatile, geary_service_provider_type_id);
	}
	return geary_service_provider_type_id__volatile;
}

